# Diffusion .NET Client Library Changes

## Version 6.10.0

Bugs fixed:

* Setting NoReconnection on a .NET session did not disable reconnection. This has now been fixed.
* The dotnet client incorrectly accepted empty strings as valid JSON. This has now been fixed.

Highlights:

* The dotnet client can now convert a session ID from a string with the SessionIdFromString method.
* TopicPermission was deprecated at release 6.5 in favor of PathPermission. It has been removed at this release along with all associated methods.
* The dotnet client provides the ability for Primary servers to initiate Remote Server connections.
* Routing topic type has been removed.
* The UpdateConstraint API has been extended to allow for conditional constraints which can check the value of a topic or JSON field using operators like GT (greater than), LT (less than) etc.
* The update stream builder now allows a IRecoverableUpdateStream to be created that can be used to recover automatically from transient clustering exceptions.
* It is now possible to form compound update constraints using an 'or' operator as well as 'and'.
* The dotnet client provides the ability to retrieve metrics using the API.

Added:

* `PushTechnology.ClientInterface.Client.Features.Control.Clients.RemoteServerType`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.RemoteServerType{get;}->RemoteServerType`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder<T>.Reset()->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiator`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiator.Urls{get;}->List<string>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiator.Connector{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiator.RetryDelay{get;}->int`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiatorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiatorBuilder.RetryDelay(int)->IPrimaryInitiatorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IPrimaryInitiatorBuilder.Build(string,List<string>,string)->IPrimaryInitiator`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryServer`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryServer.ServerUrl{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryServer.Principal{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryServer.ConnectionOptions{get;}->Dictionary<RemoteServerConnectionOption, string>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryServer.MissingTopicNotificationFilter{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>.Principal(string)->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>.Credentials(ICredentials)->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>.ConnectionOptions(Dictionary<RemoteServerConnectionOption, string>)->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>.ConnectionOption(RemoteServerConnectionOption,string)->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryBuilder<T>.MissingTopicNotificationFilter(string)->T`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryInitiator`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryInitiator.ServerUrl{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryInitiatorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryInitiatorBuilder.Build(string,string)->ISecondaryInitiator`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryAcceptor`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryAcceptor.PrimaryHostName{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryAcceptorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISecondaryAcceptorBuilder.Build(string,string)->ISecondaryAcceptor`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion<T>`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion<T>.NewRemoteServerBuilder(RemoteServerType)->IRemoteServerBuilder<T>`
* `PushTechnology.ClientInterface.Client.Features.UpdateConstraintOperator`
* `PushTechnology.ClientInterface.Client.Features.IPartialJSON.With<TValue>(string,UpdateConstraintOperator,TValue)->IPartialJSON`
* `PushTechnology.ClientInterface.Client.Features.IUpdateConstraintFactory.Value<TValue>(UpdateConstraintOperator,TValue)->IUpdateConstraint`
* `PushTechnology.ClientInterface.Client.Features.IUpdateConstraint.Or(IUpdateConstraint)->IUpdateConstraint`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Build<TValue>(string,RetryStrategy)->IRecoverableUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Features.IRecoverableUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Features.IRecoverableUpdateStream<TValue>.IsRecoverable{get;}->bool`
* `PushTechnology.ClientInterface.Client.Features.IRecoverableUpdateStream<TValue>.RecoverAsync()->Task`
* `PushTechnology.ClientInterface.Client.Features.IRecoverableUpdateStream<TValue>.RecoverAsync(CancellationToken)->Task`
* `PushTechnology.ClientInterface.Client.Features.Metrics.MetricsRequest()->IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.MetricType`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample.Name{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample.LabelNames{get;}->List<string>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample.LabelValues{get;}->List<string>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample.Timestamp{get;}->long?`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSample.Value{get;}->double`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSampleCollection`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSampleCollection.Name{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSampleCollection.Type{get;}->MetricType`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSampleCollection.Unit{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricSampleCollection.Samples{get;}->List<IMetricSample>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.Filter(HashSet<string>)->IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.Filter(string)->IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.Server(string)->IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.CurrentServer{get;}->IMetricsRequest`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.FetchAsync()->Task<IMetricsResult>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsRequest.FetchAsync(CancellationToken)->Task<IMetricsResult>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsResult`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsResult.ServerNames{get;}->HashSet<string>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricsResult.GetMetrics(string)->List<IMetricSampleCollection>`

Removed:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.INCOMPATIBLE_PARENT`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IncompatibleParentTopicException`
* `PushTechnology.ClientInterface.Client.Features.ISecurity.GetPathPermissionsAsync(string)->Task<IReadOnlyCollection<TopicPermission>>`
* `PushTechnology.ClientInterface.Client.Features.ISecurity.GetPathPermissionsAsync(string,CancellationToken)->Task<IReadOnlyCollection<TopicPermission>>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IRole.DefaultTopicPermissions{get;}->IReadOnlyCollection<TopicPermission>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IRole.TopicPermissions{get;}->IReadOnlyDictionary<string,IReadOnlyCollection<TopicPermission>>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IScriptBuilder.SetDefaultTopicPermissions(string,IEnumerable<TopicPermission>)->IScriptBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IScriptBuilder.SetTopicPermissions(string,string,IEnumerable<TopicPermission>)->IScriptBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IScriptBuilder.RemoveTopicPermissions(string,string)->IScriptBuilder`
* `PushTechnology.ClientInterface.Security.GeneralTopicPermissions{get;}->IReadOnlyDictionary<string, IReadOnlyCollection<TopicPermission>>`
* `PushTechnology.ClientInterface.Client.Types.TopicPermission`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.ROUTING`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.AddRoutingSubscriptionHandler(string,IRoutingSubscriptionRequestHandler)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.SessionId{get;}->ISessionId`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.TopicPath{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.Defer()->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.Route(string,ISubscriptionCallback)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.Route<TC>(string,TC,ISubscriptionContextCallback<TC>)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequestHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequestHandler.OnSubscriptionRequest(IRoutingSubscriptionRequest)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.RoutingSubscriptionRequestHandlerDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.RoutingSubscriptionRequestHandlerDefault.OnSubscriptionRequest(IRoutingSubscriptionRequest)->void` 
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Retry(int,int,int)->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.NoRetry()->IUpdateStreamBuilder`

Deprecated:

* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServer.Principal{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServer.ServerUrl{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServer.MissingTopicNotificationFilter{get;}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServer.ConnectionOptions{get;}->Dictionary<RemoteServerConnectionOption, string>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Factories.NewRemoteServerBuilder()->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.IPartialJSON.With<TValue>(string,TValue)->IPartialJSON`


## Version 6.9.0

Bugs fixed:

* The performance of topic updates can vary considerably across sessions. This has been fixed.

Highlights:

* The dotnet client is able to automatically retry the initial connection to the server if it fails.
* The IFilteredRequestCallback interface used in the IMessaging.SendRequestToFilterAsync method no longer inherits from the Callbacks.IStream interface.
* The Topic metric collector now has a property for grouping by topic views.

Changes:

* `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse> no longer inherits from Callbacks.IStream`

Added:

* `PushTechnology.ClientInterface.Client.Features.ITopicUpdate.NewUpdateStreamBuilder()->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Specification( ITopicSpecification topicSpecification )->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Constraint( IUpdateConstraint updateConstraint )->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Retry( int retryInterval, int numberOfRetries, int bufferSize )->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Reset()->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.NoRetry()->IUpdateStreamBuilder`
* `PushTechnology.ClientInterface.Client.Features.IUpdateStreamBuilder.Build<TValue>( string path )->IUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Session.ISessionAttributes.InitialRetryStrategy{get;}->RetryStrategy`
* `PushTechnology.ClientInterface.Client.Session.ISessionFactory.InitialRetryStrategy( RetryStrategy strategy )->ISessionFactory`
* `PushTechnology.ClientInterface.Client.Session.RetryStrategy`
* `PushTechnology.ClientInterface.Client.Session.RetryStrategy.NO_RETRY`
* `PushTechnology.ClientInterface.Client.Session.RetryStrategy.Interval{get;}->int`
* `PushTechnology.ClientInterface.Client.Session.RetryStrategy.Attempts{get;}->int`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollector.GroupsByTopicView{get;}->bool`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollectorBuilder.GroupByTopicView( bool groupByTopicView )->ITopicMetricCollectorBuilder`

Removed:

* `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse>.OnClose()->void`
* `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse>.OnError( ErrorReason errorReason )->void`

Deprecated:

* `PushTechnology.ClientInterface.Client.Features.ITopicUpdate.CreateUpdateStream<TValue>( string path )->IUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Features.ITopicUpdate.CreateUpdateStream<TValue>( string path, IUpdateConstraint constraint )->IUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Features.ITopicUpdate.CreateUpdateStream<TValue>( string path, ITopicSpecification specification )->IUpdateStream<TValue>`
* `PushTechnology.ClientInterface.Client.Features.ITopicUpdate.CreateUpdateStream<TValue>( string path, ITopicSpecification specification, IUpdateConstraint constraint )->IUpdateStream<TValue>`


## Version 6.8.0

Bugs fixed:

* An issue was identified with the .Net client's handling of partial reads. This has now been addressed.

Highlights:

* SessionEstablishmentTransientException has been added to indicate there was a transient problem when establishing a session.
* The MaximumGroups property has been added to metric collectors to limit the number of dimensions created by a metric collector.
* The Topic metric collector now has a property for grouping by path segments.
* The validation of topic views has now been changed to ensure that any 'insert' clauses happen after 'patch' clauses.
* The TopicViews feature of the Client APIs now has a new GetTopicView method allowing a single topic view to be retrieved by name.

Added:

* `PushTechnology.ClientInterface.Client.Session.SessionEstablishmentException`
* `PushTechnology.ClientInterface.Client.Session.SessionEstablishmentTransientException`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollector.MaximumGroups{get; set;}->int`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollectorBuilder.MaximumGroups( int limit )->IMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollector.GroupByPathPrefixParts{get;}->int`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollectorBuilder.GroupByPathPrefixParts( int parts )->ITopicMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.ITopicViews.GetTopicViewAsync( string name )->Task<ITopicView>`
* `PushTechnology.ClientInterface.Client.Features.ITopicViews.GetTopicViewAsync( string name, CancellationToken cancellationToken )->Task<ITopicView>`


## Version 6.7.0

Bugs fixed:

* Credentials type is incorrect when authenticating.

Highlights:

* New Session Trees feature has been added providing a virtual view of the topic tree presented to a session by fetch and subscription operations.
* Messaging Control has been removed.
* Topic Views has a new 'type' clause which allows you to specify a topic type for the generated reference topic which may be different from the selected source topic type.
* Routing topics are deprecated in favour of session trees.
* New Metrics feature has been added for creating and maintaining Session Metric Collectors and Topic Metric Collectors.
* The missing topic notification has been extended to contain the session properties of the originating session and the server name(s) of originating servers.
* Missing topic notifications can now be propagated via Remote Servers from secondary to primary servers.
* Topic Views has a new 'patch' clause which allows you to specify that a JSON patch is applied to the reference topic value.

Changes:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.FilteredRequestCallbackDefault<TResponse>` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse>`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.FilteredRequestCallbackDefault<TResponse>.OnResponse( ISessionId sessionId, TResponse response )->void` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse>.OnResponse( ISessionId sessionId, TResponse response )->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.FilteredRequestCallbackDefault<TResponse>.OnResponseError( ISessionId sessionId, Exception exception )->void` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IFilteredRequestCallback<TResponse>.OnResponseError( ISessionId sessionId, Exception exception )->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestContext` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestContext`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestContext.SessionId{get}->ISessionId` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestContext.SessionId{get}->ISessionId`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestContext.Path{get}->string` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestContext.Path{get}->string`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestContext.SessionProperties{get}->IReadOnlyDictionary<string, string>` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestContext.SessionProperties{get}->IReadOnlyDictionary<string, string>`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestHandler<TRequest, TResponse>` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestHandler<TRequest, TResponse>`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestHandler<TRequest, TResponse>.OnRequest( TRequest request, IRequestContext context, IResponder<TResponse> responder )->void` has changed namespace to `PushTechnology.ClientInterface.Client.Features.IRequestHandler<TRequest, TResponse>.OnRequest( TRequest request, IRequestContext context, IResponder<TResponse> responder )->void`.

Added:

* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.REMOTE_SERVER_EXISTS`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.INVALID_BRANCH_MAPPING`
* `PushTechnology.ClientInterface.Client.Types.PathPermission.EXPOSE_BRANCH`
* `PushTechnology.ClientInterface.Client.Features.TopicUnsubscribeReason.BRANCH_MAPPINGS`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.PutBranchMappingTableAsync( IBranchMappingTable branchMappingTable )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.PutBranchMappingTableAsync( IBranchMappingTable branchMappingTable, CancellationToken cancellationToken )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.GetSessionTreeBranchesWithMappingsAsync()->Task<IReadOnlyCollection<string>>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.GetSessionTreeBranchesWithMappingsAsync(CancellationToken cancellationToken )->Task<IReadOnlyCollection<string>>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.GetBranchMappingTableAsync( string sessionTreeBranch )->Task<IBranchMappingTable>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.ISessionTrees.GetBranchMappingTableAsync( string sessionTreeBranch, CancellationToken cancellationToken )->Task<IBranchMappingTable>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMapping`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMapping.SessionFilter{get; set;}->string`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMapping.TopicTreeBranch{get; set;}->string`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTable`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTable.SessionTreeBranch{get; set;}->string`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTable.BranchMappings{get}->IReadOnlyCollection<IBranchMapping>`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTableBuilder`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTableBuilder.Reset()->IBranchMappingTableBuilder`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTableBuilder.AddBranchMapping( string sessionFilter, string topicTreeBranch )->IBranchMappingTableBuilder`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.IBranchMappingTableBuilder.Create( string sessionTreeBranch )->IBranchMappingTable`
* `PushTechnology.ClientInterface.Client.Features.SessionTrees.InvalidBranchMappingException`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.NewBranchMappingTableBuilder()->IBranchMappingTableBuilder`
* `PushTechnology.ClientInterface.Client.Session.ISession.SessionTrees{get}->ISessionTrees`
* `PushTechnology.ClientInterface.Client.Session.ISession.Metrics{get}->IMetrics`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.PutSessionMetricCollectorAsync( ISessionMetricCollector collector )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.PutSessionMetricCollectorAsync( ISessionMetricCollector collector, CancellationToken cancellationToken )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.ListSessionMetricCollectorsAsync()->Task<List<ISessionMetricCollector>>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.ListSessionMetricCollectorsAsync( CancellationToken cancellationToken )->Task<List<ISessionMetricCollector>>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.RemoveSessionMetricCollectorAsync( string name )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.RemoveSessionMetricCollectorAsync( string name, CancellationToken cancellationToken )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.PutTopicMetricCollectorAsync( ITopicMetricCollector collector )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.PutTopicMetricCollectorAsync( ITopicMetricCollector collector, CancellationToken cancellationToken )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.ListTopicMetricCollectorsAsync()->Task<List<ITopicMetricCollector>>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.ListTopicMetricCollectorsAsync( CancellationToken cancellationToken )->Task<List<ITopicMetricCollector>>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.RemoveTopicMetricCollectorAsync( string name )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetrics.RemoveTopicMetricCollectorAsync( string name, CancellationToken cancellationToken )->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollector`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollector.Name{get; set;}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollector.ExportsToPrometheus{get; set;}->bool`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollectorBuilder.ExportsToPrometheus( bool exportsToPrometheus )->IMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.IMetricCollectorBuilder.Reset()->IMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollector`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollector.TopicSelector{get}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollector.GroupsByTopicType{get}->bool`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollectorBuilder.GroupByTopicType( bool groupByTopicType )->ITopicMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ITopicMetricCollectorBuilder.Create( string name, string topicSelector )->ITopicMetricCollector`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollector`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollector.SessionFilter{get;set;}->string`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollector.GroupByProperties{get}->List<string>`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollector.RemovesMetricsWithNoMatches{get;set;}->bool`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollectorBuilder.GroupByProperty( string propertyName )->ISessionMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollectorBuilder.GroupByProperties( List<string> propertyNames )->ISessionMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollectorBuilder.RemoveMetricsWithNoMatches( bool remove )->ISessionMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Features.Metrics.ISessionMetricCollectorBuilder.Create( string name, string sessionFilter )->ISessionMetricCollector`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.NewSessionMetricCollectorBuilder()->ISessionMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.NewTopicMetricCollectorBuilder()->ITopicMetricCollectorBuilder`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.NewRemoteServerBuilder()->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMissingTopicNotification.SessionProperties{get}->Dictionary<string, string>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMissingTopicNotification.ServerNames{get}->List<string>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( IRemoteServer remoteServer )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( IRemoteServer remoteServer, CancellationToken cancellationToken )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.MissingTopicNotificationFilter{get}->string`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.Principal( string principal )->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.Credentials( ICredentials credentials )->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.ConnectionOptions( Dictionary<RemoteServerConnectionOption, string> connectionOptions )->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.ConnectionOption( RemoteServerConnectionOption connectionOption, string value )->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.MissingTopicNotificationFilter( string filter )->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.Reset()->IRemoteServerBuilder`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServerBuilder.Create( string name, string url )->IRemoteServer`

Removed:

* `PushTechnology.ClientInterface.Client.Session.ISession.MessagingControl{get}->IMessagingControl`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestAsync<TRequest, TResponse>( ISessionId sessionId, string path, TRequest request, CancellationToken cancellationToken )->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestAsync<TRequest, TResponse>( ISessionId sessionId, string path, TRequest request )->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.AddRequestHandlerAsync<TRequest, TResponse>( string path, IRequestHandler<TRequest, TResponse> handler, CancellationToken cancellationToken, params string[] sessionProperties )->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.AddRequestHandlerAsync<TRequest, TResponse>( string path, IRequestHandler<TRequest, TResponse> handler, params string[] sessionProperties )->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestToFilterAsync<TRequest, TResponse>( string filter, string path, TRequest request, IFilteredRequestCallback<TResponse> callback, CancellationToken cancellationToken )->Task<int>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestToFilterAsync<TRequest, TResponse>( string filter, string path, TRequest request, IFilteredRequestCallback<TResponse> callback )->Task<int>`

Deprecated:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.AddRoutingSubscriptionHandler( string topicPath, IRoutingSubscriptionRequestHandler handler )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequestHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.RoutingSubscriptionRequestHandlerDefault`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.ROUTING`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( string name, string url, string principal, ICredentials credentials )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( string name, string url, string principal, ICredentials credentials, CancellationToken cancellationToken )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( string name, string url, string principal, ICredentials credentials, Dictionary<RemoteServerConnectionOption, string> connectionOptions )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IRemoteServers.CreateRemoteServerAsync( string name, string url, string principal, ICredentials credentials, Dictionary<RemoteServerConnectionOption, string> connectionOptions, CancellationToken cancellationToken )->Task<IRemoteServer>`
* `PushTechnology.ClientInterface.Client.Callbacks.IContextCallback`
* `PushTechnology.ClientInterface.Client.Callbacks.IContextStream`
* `PushTechnology.ClientInterface.Client.Callbacks.IServerHandler`
* `PushTechnology.ClientInterface.Client.Features.ICallback`
* `PushTechnology.ClientInterface.Client.Features.IContextCallback`
* `PushTechnology.ClientInterface.Client.Features.IRegisteredHandler`
* `PushTechnology.ClientInterface.Client.Features.IServerHandler`
* `PushTechnology.ClientInterface.Client.Features.ITopicTreeHandler`
* `PushTechnology.ClientInterface.Client.Features.ISecurity.ChangePrincipal( string principal, ICredentials credentials, IChangePrincipalCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ISecurity.ChangePrincipal<TContext>( string principal, ICredentials credentials, TContext context, IChangePrincipalContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.IChangePrincipalCallback`
* `PushTechnology.ClientInterface.Client.Features.IChangePrincipalContextCallback`
* `PushTechnology.ClientInterface.Client.Features.IPingCallback`
* `PushTechnology.ClientInterface.Client.Features.IPingContextCallback`
* `PushTechnology.ClientInterface.Client.Features.IPings.PingServer( IPingCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.IPings.PingServer<TContext>( TContext context, IPingContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopicsCompletionCallback`
* `PushTechnology.ClientInterface.Client.Features.ITopicsCompletionContextCallback`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Subscribe( ITopicSelector selector, ITopicsCompletionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Subscribe( string topics, ITopicsCompletionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Subscribe<TContext>( ITopicSelector selector, TContext context, ITopicsCompletionContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Subscribe<TContext>( string topics, TContext context, ITopicsCompletionContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Unubscribe( ITopicSelector selector, ITopicsCompletionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Unsubscribe( string topics, ITopicsCompletionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Unsubscribe<TContext>( ITopicSelector selector, TContext context, ITopicsCompletionContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.Unsubscribe<TContext>( string topics, TContext context, ITopicsCompletionContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IConfigurationCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IConfigurationContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.ISecurityControl.GetSecurity( IConfigurationCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.ISecurityControl.GetSecurity<TContext>( TContext context, IConfigurationContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IUpdateStoreCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.IUpdateStoreContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.ISecurityStoreFeature.UpdateStore( string commandScript, IUpdateStoreCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SecurityControl.ISecurityStoreFeature.UpdateStore<TContext>( string commandScript, TContext context, IUpdateStoreContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IConfigurationCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IConfigurationContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISystemAuthenticationControl.GetSystemAuthentication( IConfigurationCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISystemAuthenticationControl.GetSystemAuthentication<TContext>( TContext context, IConfigurationContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlAddCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlAddContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlRemovalCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlRemovalContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopic( string topicPath, ITopicSpecification specification, ITopicControlAddCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopic<TContext>( string topicPath, ITopicSpecification specification, TContext context, ITopicControlAddContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.Remove( string topicSelector, ITopicControlRemovalCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.Remove<TContext>( string topicSelector, TContext context, ITopicControlRemovalContextCallback<TContext> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMissingTopicHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.NewSpecification( TopicType topicType )->ITopicSpecification`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddMissingTopicHandler( string topicPath, IMissingTopicHandler handler )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionByFilterCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionByFilterContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Subscribe( ISessionId session, string topics, ISubscriptionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Subscribe( ISessionId session, ITopicSelector topics, ISubscriptionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Subscribe<TC>( ISessionId session, string topics, TC context, ISubscriptionContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Subscribe<TC>( ISessionId session, ITopicSelector topics, TC context, ISubscriptionContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Unsubscribe( ISessionId session, string topics, ISubscriptionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Unsubscribe( ISessionId session, ITopicSelector topics, ISubscriptionCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Unsubscribe<TC>( ISessionId session, string topics, TC context, ISubscriptionContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.Unsubscribe<TC>( ISessionId session, ITopicSelector topics, TC context, ISubscriptionContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.SubscribeByFilter( string filter, string topics, ISubscriptionByFilterCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.SubscribeByFilter( string filter, ITopicSelector topics, ISubscriptionByFilterCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.SubscribeByFilter<TC>( string filter, string topics, TC context, ISubscriptionByFilterContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.SubscribeByFilter<TC>( string filter, ITopicSelector topics, TC context, ISubscriptionByFilterContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.UnsubscribeByFilter( string filter, string topics, ISubscriptionByFilterCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.UnsubscribeByFilter( string filter, ITopicSelector topics, ISubscriptionByFilterCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.UnsubscribeByFilter<TC>( string filter, string topics, TC context, ISubscriptionByFilterContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionControl.UnsubscribeByFilter<TC>( string filter, ITopicSelector topics, TC context, ISubscriptionByFilterContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesContextCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.Close( ISessionId clientSessionId, IClientCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.Close<TC>( ISessionId clientSessionId, TC context, IClientContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.GetSessionProperties( ISessionId sessionId, List<string> requiredProperties, ISessionPropertiesCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.GetSessionProperties<TC>( ISessionId sessionId, List<string> requiredProperties, TC context, ISessionPropertiesContextCallback<TC> callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetConflated( ISessionId clientSessionId, bool conflate, IClientCallback callback )->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetConflated<TC>( ISessionId clientSessionId, bool conflate, TC context, IClientContextCallback<TC> callback )->void`
